unit Funkcioj;

interface

    uses Kursoesp,  {$IFDEF LINUX} Libc, {$ENDIF} QT {$IFDEF MSWINDOWS} , Windows {$ENDIF}, SysUtils, Classes, QGraphics, QControls, QForms, QDialogs,
  QStdCtrls, QExtCtrls, QComCtrls, inifiles,
  QClipbrd, Unit19, QStaticText, Figurejo_d, Math;

    function getMemoText(memo : TMemo) : WideString;
    procedure setMemoText(memo : TMemo; txt : WideString);
    function removeChr13(s : WideString) : WideString;
    procedure Cxapelo(var Key: Char; Sender: TObject);
    Function CxSist(frazo: WideString; iSistemo: integer): WideString;
    procedure SendasMsg( Pagxaro: TPageControl);
    procedure SavasEk( Pagxaro: TPageControl);
    procedure SxargxasEk( Var Pagxaro: TPageControl);
    procedure Trad( Var Pagxaro: TPageControl; Patro: string);
    function  konvlitero(sVorto: WideString; lMinusklo: boolean): WideString;
    function  SenPunkto(sFrazo: WideString): WideString;
    procedure KorektaVorto(var Vorto: TStaticText; Teksto: WideString);
    procedure Mesagxo(iEraraj, iKorektaj: integer);
    procedure Ne;
    procedure Jes;
    procedure Atendu( Sekundoj : Integer);
    procedure Noteto;
    procedure Sinkronigu;
    procedure Saluton;
    procedure Adiau;
    procedure Haltu;
    procedure Traduku;
    procedure LuduMp3(Sender: TObject);
    procedure Tradukas(Sendinto: TObject; Nomo : String);
    function  Matriz(var Mat: TFrazo; ek: string; tipo: string): integer;
    function  Matriz2(var Mat: TDigits; ek: string; tipo: string): integer;
    function RedonasLecionon( sEnhavujo: string): string;
    function  SpecLit(Teksto: String): WideString;
    function  SpecLitSav(Teksto: WideString): UTF8String;
    function UTFDekodigo(Teksto: String): WideString;
    procedure VokasEksteran(Komando: String; Tipo: Integer);

implementation

function  Matriz(var Mat:TFrazo; ek: string; tipo: string): integer;
Var i,j: integer;
    F: TIniFile;
    Listo : TStringList;
begin
Listo := TStringList.Create();
if (tipo = 'T') and (sLingvo <> 'Portugues') then begin
   Tradukado.ReadSection('Ekzerco-'+ek, Listo);
   For i := 0 to Listo.Count -1 do
       Mat[i] := SpecLit(Tradukado.ReadString('Ekzerco-'+ek, IntToStr(i), 'Ne Tradukita'));
   end
else begin
   F := TIniFile.Create(Vojo + 'ekzercoj/' + 'ekz' + copy(ek,1,2) + '.dat');
   F.ReadSection(ek+tipo, Listo);
   For i := 0 to Listo.Count -1 do
       Mat[ i ] := SpecLit(F.ReadString( ek+tipo, Listo[i], ''));
   end;

j := Listo.Count;
Matriz := j;
Listo.Free;
end;

function  Matriz2(var Mat: TDigits; ek: string; tipo: string): integer;
Var i,j,k: integer;
    sTemp, sTemp2: Widestring;
    F: TIniFile;
    Listo : TStringList;
begin
For i := 0 to 100 do
    For j := 0 to 10 do
        Mat[i,j] := '';
Listo := TStringList.Create();
F := TIniFile.Create(Vojo + 'ekzercoj/' + 'ekz' + copy(ek,1,2) + '.dat');
F.ReadSection(ek+tipo, Listo);
For i := 0 to Listo.Count -1 do begin
    STemp := SpecLit(F.ReadString(ek+tipo, Listo[i], ''));
    sTemp2 := '';
    k := 0;
    for j := 1 to length(sTemp) do
        if sTemp[j] <> #126 then
           sTemp2 := sTemp2 + sTemp[j]
        else begin
           Mat[ i, k ] := sTemp2;
           inc(k);
           sTemp2 := '';
           end;
    Mat[ i, k ] := sTemp2;
    end;
j := Listo.Count;
Matriz2 := j;
Listo.Free;

end;

Procedure LuduMp3(Sender: TObject);
Var
  sTeksto: Widestring;
  sDosiero: string;
begin
if (Sender as TButton).Tag > 0 then
   sDosiero := 'btn' + copy((Sender as TButton).Name,7,3) + '.mp3'
else begin
   sTeksto := (Sender as TButton).Caption;
   sTeksto := konvlitero(sTeksto, true);
   sTeksto := CxSist(sTeksto, 1);
   if sTeksto = 'aux' then
      sTeksto := 'auh';
   sDosiero := sTeksto + '.mp3';
   end;
if fileexists(vojo + 'sonoj/lec' + SonLeciono +'/'+sDosiero) then begin
   Kurso.mp3.InputOpen(vojo + 'sonoj/lec' + SonLeciono +'/'+sDosiero);
   Kurso.mp3.play;
   end
else
   MessageDlg(smNeSono, mtInformation, [mbOK], 0);
end;

procedure Tradukas(Sendinto: TObject; Nomo : String);
Begin

if (sLingvo <> 'Portugues') and Tradukilo then
   if not (Form19.Visible) then begin
      Kurso.Tradukota := Sendinto;
      sEnhavujo := Nomo;
      Form19.ShowModal;
      end;
end;

function RedonasLecionon( sEnhavujo: string): string;
Var Titolo : string;
Begin
   If sEnhavujo = 'Form1' then   // En la traduka dosiero la Form havas tiujn chi nomojn.
      Titolo := 'lec01'
   else if sEnhavujo = 'Form2' then
      Titolo := 'lec02'
   else if sEnhavujo = 'Form3' then
      Titolo := 'lec03'
   else if sEnhavujo = 'Form4' then
      Titolo := 'lec04'
   else if sEnhavujo = 'Form5' then
      Titolo := 'lec05'
   else if sEnhavujo = 'Form5A' then
      Titolo := 'lec05A'
   else if sEnhavujo = 'Form6' then
      Titolo := 'lec06'
   else if sEnhavujo = 'Form7' then
      Titolo := 'lec07'
   else if sEnhavujo = 'Form8' then
      Titolo := 'lec08'
   else if sEnhavujo = 'Form9' then
      Titolo := 'lec09'
   else if sEnhavujo = 'Form10' then
      Titolo := 'lec10'
   else if sEnhavujo = 'Form11' then
      Titolo := 'lec11'
   else if sEnhavujo = 'Form12' then
      Titolo := 'lec12'
   else if sEnhavujo = 'Form13' then
      Titolo := 'konfig'
   else if sEnhavujo = 'Form15' then
      Titolo := 'menuo4';

   RedonasLecionon := titolo;
End;

procedure Traduku;
Begin
   Kurso.KiuLingvo;
   With konfiguro do begin
      sLingvo := ReadString('Gxenerala', 'Lingvo', 'Portugues');
      sTiparo := ReadString('Gxenerala', 'Tiparo', 'Arial');
      sTradukoDosiero := ReadString('Gxenerala', 'Dosiero', '');
      lKorektanto := ReadBool('Gxenerala', 'Korektanto', false);
      lCxapeligo := ReadBool('Gxenerala', 'Cxapeligo', true);
      sKorNomo := ReadString('Gxenerala', 'Nomo', '');
      sKorAdreso := ReadString('Gxenerala', 'Adreso', '');
      iSistemo := ReadInteger('Gxenerala', 'Sistemo', 0);
      LastaLeciono := ReadInteger('Gxenerala', 'LastaLeciono', 1);
      LastaPagxo := ReadInteger('Gxenerala', 'LastaPagxo', 1);
      Tradukilo := ReadBool('Gxenerala', 'Tradukilo', false);
      sEsperanta_Tiparo := ReadString('Gxenerala', 'Esperanta_Tiparo', 'lucida sans');
      sMP3 := ReadString('Gxenerala', 'MP3', 'mpg123');
      sWavPlay := ReadString('Gxenerala', 'WavPlay', 'wavplay');
      sWavRec := ReadString('Gxenerala', 'WavRec', 'wavrec -t 5');
      sNavigilo := ReadString('Gxenerala', 'Navigilo', 'konqueror');
      sMesaghilo := ReadString('Gxenerala', 'Mesaghilo', 'kmail');
      end;
   Kurso.mp3.Komando := sMP3;
   if Screen.Fonts.IndexOf(sTiparo) < 0 then
      sTiparo := Screen.HintFont.Name;

   if sLingvo <> 'Portugues' then begin
      Tradukado := TRKSIniFile.Create(Vojo + 'tradukoj/'+ sTradukoDosiero);
      end;
   if sLingvo = 'Portugues' then
      With Kurso do begin
      iKodaro := 0;
      KioEstas.Caption := 'O que  o Esperanto?';
      KielUzi.Caption := 'Como usar o Curso';
      Konfigurado.Caption := 'Configuraes';
      Kreditoj.Caption := 'Crditos';
      Eliri.Caption := 'Sair';
      KieButono.Caption := 'Onde eu parei?';
      smRekomencu := 'Para efetivar a Traduo, saia do programa e inicie-o novamente.';
      smGratulon := 'Parabns, o seu resultado foi muito bom!';
      smDenove   := 'O seu resultado no foi bom. Tente novamente!';
      smModifis := 'Foram feitas mudanas na configurao. Deseja salv-las?';
      smTondujo := 'Em seguida ser enviado o exerccio para o Monitor. No corpo da mensagem, tecle Ctrl+V para colar o texto.';
      smDevasHaviKor := 'Voc ainda no indicou um Monitor para corrigir os exerccios. Para faz-lo, use a opo Configurao do Menu Principal';
      smDevasSavi := 'Voc fez alteraes nos exerccios. Deseja salv-las?';
      smKoverto := 'Envia o exerccio para o professor';
      smDisketo := 'Salva os exerccios';
      smPordo   := 'Retorna ao Menu Principal';
      smLigilo  := 'O Curso na Internet';
      smNePasvorto := 'Senha Incorreta!';
      Antauen   := 'Prosseguir';
      Nuligi    := 'Anular';
      smNeSono  := 'Com o objetivo de facilitar o download pela Internet, esta lio no vem acompanhada de pronncia. Visite o site do Kurso para saber se j existem arquivos de som disponveis.';
      smPrononcoNetrovita := 'Falta o arquivo abaixo. A Prtica de Pronncia no funcionar.'
      end
   else begin With Tradukado do begin
      sTradukinto := SpecLit(ReadString('Traduko', 'Tradukinto', ''));
      iKodaro     := ReadInteger('Traduko', 'Kodaro', 0);
      smRekomencu := SpecLit(ReadString('Mesagxoj', 'smRekomencu', 'Ne Tradukita'));
      smGratulon :=  SpecLit(ReadString('Mesagxoj', 'smGratulon', 'Ne Tradukita'));
      smDenove :=    SpecLit(ReadString('Mesagxoj', 'smDenove', 'Ne Tradukita'));
      smModifis :=   SpecLit(ReadString('Mesagxoj', 'smModifis','Ne Tradukita'));
      smTondujo :=   SpecLit(ReadString('Mesagxoj', 'smTondujo','Ne Tradukita'));
      smDevasHaviKor := SpecLit(ReadString('Mesagxoj', 'smDevasHaviKor','Ne Tradukita'));
      smDevasSavi := SpecLit(ReadString('Mesagxoj', 'smDevasSavi','Ne Tradukita'));
      smKoverto   := SpecLit(ReadString('Mesagxoj', 'smKoverto','Ne Tradukita'));
      smDisketo   := SpecLit(ReadString('Mesagxoj', 'smDisketo','Ne Tradukita'));
      smPordo     := SpecLit(ReadString('Mesagxoj', 'smPordo','Ne Tradukita'));
      smLigilo    := SpecLit(ReadString('Mesagxoj', 'smLigilo','Ne Tradukita'));
      smNePasvorto:= SpecLit(ReadString('Mesagxoj', 'smNePasvorto','Ne Tradukita'));
      Antauen     := SpecLit(ReadString('Mesagxoj', 'Antauen','Ne Tradukita'));
      Nuligi      := SpecLit(ReadString('Mesagxoj', 'Nuligi','Ne Tradukita'));
      smNeSono    := SpecLit(ReadString('Mesagxoj', 'smNeSono','Ne Tradukita'));
      end;
      With Kurso do begin
           KioEstas.Caption := SpecLit(Tradukado.ReadString('Menuo', 'KioEstas', 'Ne Tradukita'));
           KielUzi.Caption := SpecLit(Tradukado.ReadString('Menuo', 'KielUzi', 'Ne Tradukita'));
           Konfigurado.Caption := SpecLit(Tradukado.ReadString('Menuo', 'Konfigurado', 'Ne Tradukita'));
           Kreditoj.Caption := SpecLit(Tradukado.ReadString('Menuo', 'Kreditoj', 'Ne Tradukita'));
           Eliri.Caption := SpecLit(Tradukado.ReadString('Menuo', 'Eliri', 'Ne Tradukita'));
           KieButono.Caption := SpecLit(Tradukado.ReadString('Menuo','KieButono', 'Ne Tradukita'));
           end;
      end;
      With Kurso do begin
       KioEstas.Font.Name := sTiparo;
       KielUzi.Font.Name := sTiparo;
       Konfigurado.Font.Name := sTiparo;
       Kreditoj.Font.Name := sTiparo;
       Eliri.Font.Name := sTiparo;
       KieButono.Font.Name := sTiparo;
       Ligilo.Hint := smLigilo;
       end;

end;

function SpecLit(Teksto: String): WideString;
Begin
   Teksto := StringReplace(Teksto, #39 + '#10' + #39, #10, [rfReplaceall, rfIgnoreCase]);
   result := UTF8Decode(Teksto);
end;

function SpecLitSav(Teksto: WideString): UTF8String;
Var Rezulto: UTF8String;
Begin
   Rezulto := StringReplace( UTF8Encode(RemoveChr13(Teksto)), #10, #39 + '#10' + #39, [rfReplaceall, rfIgnoreCase]) ;
   result := Rezulto;
end;

procedure Cxapelo(var Key: Char; Sender: TObject);
Var Litero : WideString;
    MalnovaPozicio : integer;
begin
if lCxapeligo then begin
   if ((Key = 'x') or (Key = 'X') )then begin
      case AntauaLitero of
           'c': Litero := #265;
           'g': Litero := #285;
           'h': Litero := #293;
           'j': Litero := #309;
           's': Litero := #349;
           'u': Litero := #365;
           'C': Litero := #264;
           'G': Litero := #284;
           'H': Litero := #292;
           'J': Litero := #308;
           'S': Litero := #348;
           'U': Litero := #364;
       else
           Litero := Key
           end;
       if (Litero <> Key) then begin
          if (Sender is TEdit) then
             With (Sender as TEdit) do begin
                MalnovaPozicio := SelStart;
                Text := copy(Text,0, SelStart-1)+ Litero + copy(Text,SelStart+length(Litero), length(Text));
                SelStart := MalnovaPozicio;
                end
          else if (Sender is TMemo) then begin
               With (Sender as TMemo) do begin
                  If HasSelection then
                     ClearSelection
                  else begin
                     SelStart := SelStart-1;
                     SelLength := 1;
                     ClearSelection;
                     end;
                  Insert(Litero, false);
                  end;
               end;
          AntauaLitero := #0;
          Key := #0;
          end
       else
          AntauaLitero := WideChar(Key);
       end
   else
      AntauaLitero := WideChar(Key);
end;
end;

Function CxSist(frazo: WideString; iSistemo: integer): WideString;
Var Prov: WideString;
    i: integer;
    lo : WideString;
begin
if iSistemo = 0 then
   CxSist := frazo
else begin
   For i := 1 to Length(frazo) do begin
      lo := copy(frazo,i,1);
      if iSistemo = 1 then begin
          if lo = #265 then lo := 'cx' else
          if lo = #285 then lo := 'gx' else
          if lo = #293 then lo := 'hx' else
          if lo = #309 then lo := 'jx' else
          if lo = #349 then lo := 'sx' else
          if lo = #365 then lo := 'ux' else
          if lo = #264 then lo := 'Cx' else
          if lo = #284 then lo := 'Gx' else
          if lo = #292 then lo := 'Hx' else
          if lo = #308 then lo := 'Jx' else
          if lo = #348 then lo := 'Sx' else
          if lo = #364 then lo := 'Ux';
          end
      else
          if lo = #265 then lo := 'ch' else
          if lo = #285 then lo := 'gh' else
          if lo = #293 then lo := 'hh' else
          if lo = #309 then lo := 'jh' else
          if lo = #349 then lo := 'sh' else
          if lo = #365 then lo := 'u' else
          if lo = #264 then lo := 'Ch' else
          if lo = #284 then lo := 'Gh' else
          if lo = #292 then lo := 'Hh' else
          if lo = #308 then lo := 'Jh' else
          if lo = #348 then lo := 'Sh' else
          if lo = #364 then lo := 'U';
       Prov := Prov + lo;
    end;
    CxSist := Prov;
  end;
end;

procedure SendasMsg( Pagxaro: TPageControl);
var
  x : String;
  y : WideString;
  Prov: array[0..159] of WideString; // La ekzerca kapvorto
  Prov2: array[0..159] of WideString; // La lernanta respondo
  i: integer;
  Pagxo: TTabSheet;
begin
if not lKorektanto then
   MessageDlg(smDevasHaviKor, mtInformation, [mbOK], 0)
else begin
  For i := 0 to 159 do begin
      Prov[i] := '';
      Prov2[i] := '';
      end;
  Pagxo := Pagxaro.ActivePage;
  With Pagxaro.Parent do begin
  for i := 0 to ComponentCount-1 do
      if ( Components[i] is TEdit ) and ( (TEdit(Components[i]).Parent = Pagxo) or (copy(Pagxo.Name,1,8) = 'Ekzameno') ) then
         if (TEdit(Components[i]).Tag in [1..127]) then
            Prov2[TEdit(Components[i]).Tag - 1] := #9 + CxSist(TEdit(Components[i]).Text, iSistemo) + #10#10
         else
            Prov2[TEdit(Components[i]).Tag - 128] := #9 + TEdit(Components[i]).Text + #10#10
      else if ( (Components[i] is TLabel) and not(Components[i] is TStaticText) ) and ( (TLabel(Components[i]).Parent = Pagxo) or (copy(Pagxo.Name,1,8) = 'Ekzameno') ) and ( TLabel(Components[i]).Tag > 0 ) then
               Prov[ TLabel(Components[i]).Tag - 1] := TLabel(Components[i]).Caption + cr
           else if ( Components[i]  is TStaticText ) and ( (TStaticText(Components[i]).Parent = Pagxo) or (copy(Pagxo.Name,1,8) = 'Ekzameno') ) and ( TStaticText(Components[i]).Tag > 0 ) then
                   Prov[ TStaticText(Components[i]).Tag -1 ] := CxSist(TStaticText (Components[i]).Caption, iSistemo) + cr
                else if ( Components[i] is TMemo ) and ( (TMemo(Components[i]).Parent = Pagxo) or (copy(Pagxo.Name,1,8) = 'Ekzameno' )) then
                        if ( TMemo(Components[i]).Tag in [1..127] ) then
                           if ( TMemo(Components[i]).ReadOnly ) then begin
                              Prov[TMemo(Components[i]).Tag - 1] := Prov[ TMemo(Components[i]).Tag - 1]+ CxSist(GetMemoText(TMemo(Components[i])), iSistemo) + cr;
                              Prov[TMemo(Components[i]).Tag - 1] := cr + Prov[ TMemo(Components[i]).Tag - 1]+ cr;
                              end
                           else begin
                              Prov2[ TMemo(Components[i]).Tag - 1] := Prov2[ TMemo(Components[i]).Tag - 1]+ CxSist(GetMemoText(TMemo(Components[i])), iSistemo) + cr;
                              Prov2[ TMemo(Components[i]).Tag - 1] := cr + Prov2[ TMemo(Components[i]).Tag - 1]+ cr;
                              end
                        else
                           if ( TMemo(Components[i]).ReadOnly ) then begin
                              Prov[ TMemo(Components[i]).Tag - 128 ] := Prov[ TMemo(Components[i]).Tag - 127 ]+ GetMemoText(TMemo(Components[i])) + cr;
                              Prov[ TMemo(Components[i]).Tag - 128 ] := cr + Prov[ TMemo(Components[i]).Tag - 128 ]+ cr;
                              end
                           else begin
                              Prov2[TMemo(Components[i]).Tag - 128 ] := Prov2[ TMemo(Components[i]).Tag - 128 ]+ GetMemoText(TMemo(Components[i])) + cr;
                              Prov2[ TMemo(Components[i]).Tag - 128 ] := cr + Prov2[ TMemo(Components[i]).Tag - 128] + cr;
                              end;
  end;
  For i := 0 to 159 do begin
      if Prov[i] <> '' then
         y := y + Prov[i];
      if Prov2[i]<> '' then
         y := y + Prov2[i];
      end;
  x:= sKorAdreso + ' -s "' + (Pagxaro.Parent as TForm).Caption + ', Pagxo ' + IntToStr(Pagxaro.ActivePageIndex + 1)+ '"';
  if MessageDlg(smTondujo, mtInformation, [mbOK, mbCancel], 0) = mrOk then begin
     Clipboard.AsText := y;
     VokasEksteran(x, 2);
     end;
  end;
end;

procedure SavasEk( Pagxaro: TPageControl);
var
  i: integer;
begin
  With Pagxaro.Parent do begin
  for i := 0 to ComponentCount-1 do
      if ( Components[i] is TEdit ) and ( TEdit(Components[i]).Tag > 0 ) then
         Konfiguro.WriteString(Pagxaro.Parent.Name, TEdit(Components[i]).Name, UTF8Encode(TEdit(Components[i]).Text))
      else if ( Components[i] is TMemo ) and ( TMemo(Components[i]).Tag > 0 ) then
              if ( not TMemo(Components[i]).ReadOnly ) then
                 Konfiguro.WriteString(Pagxaro.Parent.Name, TMemo(Components[i]).Name, SpecLitSav(GetMemoText(TMemo(Components[i]))));
  Konfiguro.UpdateFile;
  end;
end;

procedure SxargxasEk( Var Pagxaro: TPageControl);
var
  i: integer;
begin
  With Pagxaro.Parent do
  for i := 0 to ComponentCount-1 do
      if ( Components[i] is TEdit ) and ( TEdit(Components[i]).Tag > 0 ) then
          TEdit(Components[i]).Text := SpecLit(Konfiguro.ReadString(Pagxaro.Parent.Name, TEdit(Components[i]).Name, '' ))
      else if ( Components[i] is TMemo ) and ( TMemo(Components[i]).Tag > 0 ) then
              if ( not TMemo(Components[i]).ReadOnly ) then
                   SetMemoText(TMemo(Components[i]), SpecLit(Konfiguro.ReadString(Pagxaro.Parent.Name, TMemo(Components[i]).Name, '')));
end;

procedure Trad( Var Pagxaro: TPageControl; Patro: string);
var
  i,j: integer;
begin
With Pagxaro.Parent do
   for i := 0 to ComponentCount-1 do begin

       if ( ( Components[i] is TButton ) or (Components[i] is TStaticText) or
           (( Components[i] is TEdit ) and not( TEdit(Components[i]).Tag in [128..255] )) or
           (( Components[i] is TMemo ) and not( TMemo(Components[i]).Tag in [128..255] )) ) then begin
              TLabel(Components[i]).Font.CharSet := fcsLatin3;
              TLabel(Components[i]).Font.Name := sEsperanta_Tiparo;
              end;

       if ( Components[i] is TImage ) and ( copy(Components[i].Name , 1,4) = 'Grad' )then
          // Sxargxas la figurujon per la ghusta figuro, depende de la lecionuja koloro
          case (Pagxaro.Parent as TForm).Color of
               $00E3CDAC : TImage(Components[i]).Picture := Figurejo.Blua_strio.Picture;
               $00C1EBBE : TImage(Components[i]).Picture := Figurejo.Verda_strio.Picture;
               $00B8EBE7 : TImage(Components[i]).Picture := Figurejo.Flava_strio.Picture;
               $00BAC1D6 : TImage(Components[i]).Picture := Figurejo.Rugxa_strio.Picture;
               end;

       if ( ( Components[i] is TLabel ) and  not(Components[i] is TStaticText)) or
           (( Components[i] is TMemo ) and ( TMemo(Components[i]).Tag in [128..255] )) or
           (( Components[i] is TEdit ) and ( TEdit(Components[i]).Tag in [128..255] )) or
           (( Components[i] is TGroupBox ) and ( TGroupBox(Components[i]).Name = 'Grupo')) or
           (( Components[i] is TStaticText ) and ( (pos('raduk',TStaticText(Components[i]).Name) > 0)  or (pos('VortoTrad',TStaticText(Components[i]).Name) > 0))) then begin
//              TLabel(Components[i]).Font.CharSet := fcsKodaro;
              TLabel(Components[i]).Font.Name := sTiparo;
              end;


       if ( ( Components[i] is TLabel ) and  not(Components[i] is TStaticText)) then
           if sLingvo <> 'Portugues' then
              TLabel(Components[i]).Caption := SpecLit(Tradukado.ReadString(Patro, TLabel(Components[i]).Name, 'Ne Tradukita' ));

       if Components[i] is TFrame then
          for j := 0 to Components[i].ComponentCount-1 do begin
              if ( Components[i].Components[j] is TImage ) and ( copy(Components[i].Components[j].Name , 1,4) = 'Grad' )then
                 case (Pagxaro.Parent as TForm).Color of
                      $00E3CDAC : TImage(Components[i].Components[j]).Picture := Figurejo.Blua_strio.Picture;
                      $00C1EBBE : TImage(Components[i].Components[j]).Picture := Figurejo.Verda_strio.Picture;
                      $00B8EBE7 : TImage(Components[i].Components[j]).Picture := Figurejo.Flava_strio.Picture;
                      $00BAC1D6 : TImage(Components[i].Components[j]).Picture := Figurejo.Rugxa_strio.Picture;
                      end;
              if ( ( Components[i].Components[j] is TButton ) or (Components[i].Components[j] is TStaticText) or
                 (( Components[i].Components[j] is TEdit ) and not( TEdit(Components[i].Components[j]).Tag in [128..255] )) or
                 (( Components[i] is TMemo ) and not( TMemo(Components[i]).Tag in [128..255] )) ) then begin
                    TLabel(Components[i].Components[j]).Font.CharSet := fcsLatin3;
                    TLabel(Components[i].Components[j]).Font.Name := sEsperanta_Tiparo;
                 end;

           if sLingvo <> 'Portugues' then begin
              if Components[i].Components[j].Name = 'Label7' then
                 TLabel(Components[i].Components[j]).Caption := SpecLit(Tradukado.ReadString('Gheneralaj', 'TFrame1.Label7', 'Ne Tradukita' ));
              if Components[i].Components[j].Name = 'PP_Label41' then
                 TLabel(Components[i].Components[j]).Caption := SpecLit(Tradukado.ReadString('Gheneralaj', 'TFrame2.PP_Label41', 'Ne Tradukita' ));
              if Components[i].Components[j].Name = 'PP_Label1' then
                 TLabel(Components[i].Components[j]).Caption := SpecLit(Tradukado.ReadString('Gheneralaj', 'TFrame2.PP_Label1', 'Ne Tradukita' ));
              if Components[i].Components[j].Name = 'Label68' then
                 TLabel(Components[i].Components[j]).Caption := SpecLit(Tradukado.ReadString('Gheneralaj', 'TFrame3.Label68', 'Ne Tradukita' ));
              if Components[i].Components[j].Name = 'Label59' then
                 TLabel(Components[i].Components[j]).Caption := SpecLit(Tradukado.ReadString('Gheneralaj', 'TFrame3.Label59', 'Ne Tradukita' ));
              if Components[i].Components[j].Name = 'Label6' then
                 TLabel(Components[i].Components[j]).Caption := SpecLit(Tradukado.ReadString('Gheneralaj', 'TFrame5.Label6', 'Ne Tradukita' ));
              if Components[i].Components[j].Name = 'Label1' then
                 TLabel(Components[i].Components[j]).Caption := SpecLit(Tradukado.ReadString('Gheneralaj', 'TFrame5.Label1', 'Ne Tradukita' ));
              end;
              if Components[i].Components[j].Name = 'Label83' then
                 if sLingvo <> 'Portugues' then begin
                    TLabel(Components[i].Components[j]).Caption := SpecLit(Tradukado.ReadString('Gheneralaj', 'TFrame4.Label83', 'Ne Tradukita' ));
                    end
                 else begin
                    TLabel(Components[i].Components[j]).Caption := 'Exerccios';
                    end;
              if Components[i].Components[j].Name = 'Label84' then begin
                 if Components[i].Name = 'TFrame41' then begin
                    if sLingvo <> 'Portugues' then begin
                       TLabel(Components[i].Components[j]).Caption := SpecLit(Tradukado.ReadString(Patro, 'TFrame41.Label84', 'Ne Tradukita' ));
                       end
                    else
                       TLabel(Components[i].Components[j]).Caption := EkzPortugale[StrToInt(copy(patro,4,2)),0];
                    end
                 else begin
                    if sLingvo <> 'Portugues' then
                       TLabel(Components[i].Components[j]).Caption := SpecLit(Tradukado.ReadString(Patro, 'Frame42.Label84', 'Ne Tradukita' ))
                    else
                       TLabel(Components[i].Components[j]).Caption := EkzPortugale[StrToInt(copy(patro,4,2)),1];
                    end;
                 end;

              if ( (Components[i].Components[j] is TLabel) and not (Components[i].Components[j] is TStaticText) ) or
                 (( Components[i].Components[j] is TEdit ) and ( TEdit(Components[i].Components[j]).Tag in [128..255] )) or
                 (( Components[i].Components[j] is TGroupBox ) and ( TGroupBox(Components[i].Components[j]).Name = 'Grupo')) or
                 (( Components[i].Components[j] is TStaticText ) and ( (pos('raduk',TStaticText(Components[i].Components[j]).Name) > 0)  or (pos('VortoTrad',TStaticText(Components[i].Components[j]).Name) > 0))) then begin
//                 TLabel(Components[i].Components[j]).Font.CharSet := fcsKodaro;
                 TLabel(Components[i].Components[j]).Font.Name := sTiparo;
                 end;
             end;
   end;
end;

function konvlitero(sVorto: WideString; lMinusklo: boolean): WideString;
Var sVortoRes: WideString;
    i: integer;
begin
for i := 1 to length(sVorto) do
    if lMinusklo then
       case sVorto[i] of
            #265, #264: sVortoRes := sVortoRes + #265;
            #285, #284: sVortoRes := sVortoRes + #285;
            #293, #292: sVortoRes := sVortoRes + #293;
            #309, #308: sVortoRes := sVortoRes + #309;
            #349, #348: sVortoRes := sVortoRes + #349;
            #365, #364: sVortoRes := sVortoRes + #365;
       else sVortoRes := sVortoRes + lowercase(sVorto[i]);
       end
    else
       case sVorto[i] of
            #265, #264: sVortoRes := sVortoRes + #264;
            #285, #284: sVortoRes := sVortoRes + #284;
            #293, #292: sVortoRes := sVortoRes + #292;
            #309, #308: sVortoRes := sVortoRes + #308;
            #349, #348: sVortoRes := sVortoRes + #348;
            #365, #364: sVortoRes := sVortoRes + #364;
       else sVortoRes := sVortoRes + uppercase(sVorto[i]);
       end;
konvlitero := sVortoRes;
end;

procedure KorektaVorto(var Vorto: TStaticText; Teksto: WideString);
Var
NumSec: SmallInt;
StartTime: TDateTime;
iQuant : integer;
begin
   Vorto.Caption := Teksto;
   StartTime := now;
   NumSec := 4;
   iQuant := 0;
   repeat
       Application.ProcessMessages;
       if now > (StartTime + (iQuant * (1/24/60/60)) /3) then begin;
          inc(iQuant);
          Vorto.Visible := not Vorto.Visible;
       end;
   until Now > StartTime + NumSec * (1/24/60/60);
   Vorto.Visible := false;
end;

procedure Mesagxo(iEraraj, iKorektaj: integer);
Var iAleat: integer;
    sMp3Dos : WideString;
begin
   sMp3dos := '';
   if round((iKorektaj / (iEraraj + iKorektaj))* 100) >= 70.00 then begin
      if lSxaltilo then begin
         iAleat := random(8);
         while not (fileexists(Vojo+'sonoj/gratulo'+IntToStr(iAleat+1)+'.mp3')) do
             iAleat := random(8);
         sMp3dos := Vojo+'sonoj/gratulo'+IntToStr(iAleat+1)+'.mp3';
         Kurso.mp3.InputOpen(sMp3dos);
         Kurso.mp3.Play;
         end;
      MessageDlg(smGratulon, mtInformation,[mbOK], 0);
      end
   else begin
      if lSxaltilo then begin
         iAleat := random(8);
         while not (fileexists(Vojo+'sonoj/nebona'+IntToStr(iAleat+1)+'.mp3')) do
             iAleat := random(8);
         sMp3dos := Vojo+'sonoj/nebona'+IntToStr(iAleat+1)+'.mp3';
         Kurso.mp3.InputOpen(sMp3dos);
         Kurso.mp3.Play;
         end;
      MessageDlg(smDenove, mtInformation,[mbOK], 0);
      end;
end;

procedure Jes;
Var iAleat, i: integer;
    sMp3dos: WideString;
begin
if lSxaltilo then begin
   iAleat := random(6);
   while iAleat = iLastaFojo do
      iAleat := random(6);
   case iAleat of
        0: sMp3dos := 'jes';
        1: sMp3dos := 'trebone';
        2: sMp3dos := 'bonege';
        3: sMp3dos := 'prave';
        4: sMp3dos := 'trafe';
        5: sMp3dos := 'korekte';
        end;
   iLastaFojo := iAleat;
   iAleat := random(8);
   i := 0;
   while not ( fileexists(Vojo+'sonoj/'+sMp3Dos+IntToStr(iAleat+1)+'.mp3')) do begin
         iAleat := random(8);
         inc(i);
         if i > 100 then
            break;
         end;   
   sMp3dos := Vojo+'sonoj/'+sMp3Dos+IntToStr(iAleat+1)+'.mp3';
   Kurso.mp3.InputOpen(sMp3dos);
   Kurso.mp3.play;
   end;
end;

procedure Ne;
Var iAleat: integer;
    sMp3Dos : WideString;
begin
if lSxaltilo then begin
   iAleat := random(8);
   while not (fileexists(Vojo+'sonoj/ne'+IntToStr(iAleat+1)+'.mp3')) do
       iAleat := random(8);
   sMp3dos := Vojo+'sonoj/ne'+IntToStr(iAleat+1)+'.mp3';
   Kurso.mp3.InputOpen(sMp3dos);
   Kurso.mp3.play;
   end;
end;

procedure Noteto;
begin
if lSxaltilo then begin
   Kurso.mp3.InputOpen(Vojo + 'sonoj/noteto.mp3');
   Kurso.mp3.play;
   end;
end;


Procedure Saluton;
Var horo, min, sek, msek: Word;
Var iAleat6: integer;
    sMp3dos: WideString;
Begin
randomize;
DecodeTime( now, Horo, Min, Sek, MSek);
if (horo >= 16) and (horo <= 20) then
   sMp3dos := 'vespero'
else if (horo >= 5) and (horo <= 11) then begin
   iAleat6 := random(2);
   if iAleat6 = 0 then
      sMp3dos := 'matenon'
   else  sMp3dos := 'tagon';
   end
else if (horo >= 12) and (horo <= 15) then
   sMp3dos := 'tagon'
else sMp3dos := 'nokton';

iAleat6 := random(8);
if fileexists(Vojo+'sonoj/'+sMp3Dos+IntToStr(iAleat6+1)+'.mp3') then
   sMp3dos := Vojo+'sonoj/'+sMp3Dos+IntToStr(iAleat6+1)+'.mp3'
else begin
   while not ( fileexists(Vojo+'sonoj/saluton'+IntToStr(iAleat6+1)+'.mp3')) do
       iAleat6 := random(8);
   sMp3dos := Vojo+'sonoj/saluton'+IntToStr(iAleat6+1)+'.mp3'
   end;
   Kurso.Mp3.InputOpen(sMp3dos);
Sinkronigu;
   Kurso.Mp3.Play;
// Atendu(Sonlongeco+1);
// Mp3.InputOpen('sonoj/kanzono.mp3');
// Kurso.mp3.play;
end;

Procedure Adiau;
Var iAleat, i: integer;
    sMp3dos: WideString;
Begin
randomize;
iAleat := random(4);
case iAleat of
     0: sMp3dos := 'ghis';
     1: sMp3dos := 'revido';
     2: sMp3dos := 'baldau';
     3: sMp3dos := 'adiau';
     end;
iAleat := random(8);
for i := 0 to 7 do
   if fileexists(Vojo+'sonoj/'+sMp3Dos+IntToStr(iAleat+1)+'.mp3') then begin
      sMp3dos := Vojo+'sonoj/'+sMp3Dos+IntToStr(iAleat+1)+'.mp3';
      break;
      end
   else
      iAleat := random(6);

Kurso.mp3.InputOpen(sMp3dos);
Sinkronigu;
Kurso.mp3.play;
end;

procedure Atendu( Sekundoj : Integer);
Var KomencaTempo : TDateTime;
begin
  KomencaTempo := now;
  repeat
     Application.ProcessMessages;
  until Now > KomencaTempo + Sekundoj * (1/24/60/60);
end;

procedure Sinkronigu;
begin
{   cPongo := random(30000);
   Kurso.Mp3.Ping(cPongo);
   repeat
      Application.ProcessMessages;
      until Pongo = cPongo;}
end;

procedure Haltu;
begin
   Kurso.Mp3.Stop;
   Sinkronigu;
   SonLongeco := 0;
end;

function SenPunkto(sFrazo: WideString): WideString;
var sFrazoRes: WideString;
    i: integer;
    cLasta: Widechar;
begin
cLasta := #32;
sFrazo := trim(sFrazo);
for i:= 1 to length(sFrazo) do
    if sFrazo[i] = ' ' then begin
       if (cLasta <> ' ') then begin
          sFrazoRes := sFrazoRes + sFrazo[i];
          cLasta := sFrazo[i];
       end
    end
    else
       if sFrazo[i] <> '.' then begin
          sFrazoRes := sFrazoRes + sFrazo[i];
          cLasta := sFrazo[i];
       end;
SenPunkto := sFrazoRes;
end;

function removeChr13(s : WideString) : WideString;
var i: Integer;
begin
 Result := '';
 for i:=1 to length(s) do
     if s[i] <> #13 then
       Result := Result + s[i];
end;

function getMemoText(memo : TMemo) : WideString;
{$ifdef WIN32}
var selectionStart, selectionLength : Integer;
{$endif}
begin

{$ifdef LINUX}
  // this is straight forward in Linux
  Result := memo.Text;
{$endif}

{$ifdef WIN32}

  // store current selection information
  selectionStart := memo.SelStart;
  selectionLength := memo.SelLength;

  // select everything and retrieve unicode value
  memo.WordWrap := False;
  memo.SelectAll;

  Result := removeChr13(memo.SelText);
  memo.WordWrap := True;

  // restore previous selection
  memo.SelStart := selectionStart;
  memo.SelLength := selectionLength;
{$endif}

end;

procedure setMemoText(memo : TMemo; txt : WideString);
begin
  memo.Clear;
  memo.Append(txt);
  memo.SelStart := 0;
  memo.SelLength := 0;
end;

function UTFDekodigo(Teksto: String): WideString;
Var i: integer;
    Nova: WideString;
    Numero : Extended;
    Numero2 : Integer;
Begin
Nova := '';
i := 1;
While i <= (length(Teksto)) do
    if ord(Teksto[i]) < $80 then begin
       Nova := Nova + Teksto[i];
       inc(i);
       end
    else if ord(Teksto[i]) < $E0 then begin
       Numero := ((ord(Teksto[i])- $C0) * Power(2,5)) + ( ord(Teksto[i+1]) - $80);
       Numero2 := Round(Numero);
       Nova := Nova + WideChar(Numero2);
       i := i+2;
       end
    else if ord(Teksto[i]) < $F0 then begin
       Numero :=  ( (ord(Teksto[i]) - $E0) * Power(2, 10)) + ((ord(Teksto[i+1])- $C0) * Power(2,6)) + ( ord(Teksto[i+2]) - $80);
       Numero2 := Round(Numero);
       Nova := Nova + WideChar(Numero2);
       i := i+3;
       end
    else if ord(Teksto[i]) < $F8 then begin
       Numero := ( (ord(Teksto[i])-$F0) * Power(2,15)) + ( (ord(Teksto[i+1]) - $E0) * Power(2,12)) + ((ord(Teksto[i+2])- $C0) * Power(2,6)) + ( ord(Teksto[i+3]) - $80);
       Numero2 := Round(Numero);
       Nova := Nova + WideChar(Numero2);
       i := i+4;
       end;
result := nova;
end;

procedure VokasEksteran(Komando: String; Tipo: Integer);
Var Tuta : String;
Begin
// Tipo 1 = ttt-ejo
// Tipo 2 = e-mesagho
If Tipo = 1 then
   Tuta := sNavigilo + ' ' + komando + ' &'
else
   Tuta := sMesaghilo + ' ' + komando + ' &';
Libc.System(Pchar(Tuta));
end;

end.
